/* libbreezy-version.h.in
 *
 * Copyright 2021 Gustav Hartvigsson
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#if !defined(LIBBREEZY_INSIDE) && !defined(LIBBREEZY_COMPILATION)
# error "Only <libbreezy.h> can be included directly."
#endif

/**
 * SECTION:libbreezyversion
 * @short_description: libbreezy version checking
 *
 * libbreezy provides macros to check the version of the library
 * at compile-time
 */

/**
 * LIBBREEZY_MAJOR_VERSION:
 *
 * libbreezy major version component (e.g. 1 if %LIBBREEZY_VERSION is 1.2.3)
 */
#define LIBBREEZY_MAJOR_VERSION (@MAJOR_VERSION@)

/**
 * LIBBREEZY_MINOR_VERSION:
 *
 * libbreezy minor version component (e.g. 2 if %LIBBREEZY_VERSION is 1.2.3)
 */
#define LIBBREEZY_MINOR_VERSION (@MINOR_VERSION@)

/**
 * LIBBREEZY_MICRO_VERSION:
 *
 * libbreezy micro version component (e.g. 3 if %LIBBREEZY_VERSION is 1.2.3)
 */
#define LIBBREEZY_MICRO_VERSION (@MICRO_VERSION@)

/**
 * LIBBREEZY_VERSION
 *
 * libbreezy version.
 */
#define LIBBREEZY_VERSION (@VERSION@)

/**
 * LIBBREEZY_VERSION_S:
 *
 * libbreezy version, encoded as a string, useful for printing and
 * concatenation.
 */
#define LIBBREEZY_VERSION_S "@VERSION@"

#define LIBBREEZY_ENCODE_VERSION(major,minor,micro) \
        ((major) << 24 | (minor) << 16 | (micro) << 8)

/**
 * LIBBREEZY_VERSION_HEX:
 *
 * libbreezy version, encoded as an hexadecimal number, useful for
 * integer comparisons.
 */
#define LIBBREEZY_VERSION_HEX \
        (LIBBREEZY_ENCODE_VERSION (LIBBREEZY_MAJOR_VERSION, LIBBREEZY_MINOR_VERSION, LIBBREEZY_MICRO_VERSION))

/**
 * LIBBREEZY_CHECK_VERSION:
 * @major: required major version
 * @minor: required minor version
 * @micro: required micro version
 *
 * Compile-time version checking. Evaluates to %TRUE if the version
 * of libbreezy is greater than the required one.
 */
#define LIBBREEZY_CHECK_VERSION(major,minor,micro)   \
        (LIBBREEZY_MAJOR_VERSION > (major) || \
         (LIBBREEZY_MAJOR_VERSION == (major) && LIBBREEZY_MINOR_VERSION > (minor)) || \
         (LIBBREEZY_MAJOR_VERSION == (major) && LIBBREEZY_MINOR_VERSION == (minor) && \
          LIBBREEZY_MICRO_VERSION >= (micro)))
